/*
 * Sponsored License - for use in support of a program or activity
 * sponsored by MathWorks.  Not for government, commercial or other
 * non-sponsored organizational use.
 *
 * mb_fm_mex_sourceRobot.cpp
 *
 * Code generation for function 'mb_fm_mex_sourceRobot'
 *
 */

/* Include files */
#include "mb_fm_mex_sourceRobot.h"

/* Function Definitions */
void mb_fm_mex_sourceRobot(double states[4], double controls[2], double
  statesdot[4], double outputs[4], double j_statesdot[24], double j_outputs[24])
{
  int i0;
  signed char j_x[6];
  signed char j_vX[6];
  signed char j_y[6];
  signed char j_vY[6];
  signed char j_aX[6];
  signed char j_aY[6];
  signed char c_tmp_j_input_sys_de333256aa3f6[36];
  int i1;
  double j_statedottmp[24];
  int i2;
  static const signed char b_j_statedottmp[24] = { 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1 };

  double j_xOut[6];
  double j_vxOut[6];
  double j_yOut[6];
  double j_vyOut[6];
  static const signed char b_j_xOut[6] = { 1, 0, 0, 0, 0, 0 };

  static const signed char b_j_vxOut[6] = { 0, 1, 0, 0, 0, 0 };

  static const signed char b_j_yOut[6] = { 0, 0, 1, 0, 0, 0 };

  static const signed char b_j_vyOut[6] = { 0, 0, 0, 1, 0, 0 };

  /* mb_fm_mex_sourceRobot */
  /*  File automatically generated by FALCON.m */
  /* === Extract Data From Input ============================================== */
  /* === Jacobians and Hessians =============================================== */
  for (i0 = 0; i0 < 6; i0++) {
    j_x[i0] = 0;
    j_vX[i0] = 0;
    j_y[i0] = 0;
    j_vY[i0] = 0;
    j_aX[i0] = 0;
    j_aY[i0] = 0;
  }

  j_x[0] = 1;
  j_vX[1] = 1;
  j_y[2] = 1;
  j_vY[3] = 1;
  j_aX[4] = 1;
  j_aY[5] = 1;

  /*  Combine Variables to states */
  /*  Combine Variables to controls */
  /* === Write Constants ====================================================== */
  /* === Call sys_de333256aa3f64854082fd9b6efede0c ============================ */
  /* SYS_DE333256AA3F64854082FD9B6EFEDE0C */
  /*     [OUT1,OUT2,OUT3,OUT4,OUT5,J_OUT1,J_OUT2,J_OUT3,J_OUT4,J_OUT5,H_OUT1,H_OUT2,H_OUT3,H_OUT4,H_OUT5] = SYS_DE333256AA3F64854082FD9B6EFEDE0C(IN1,IN2) */
  /*     This function was generated by the Symbolic Math Toolbox version 8.0. */
  /*     26-Dec-2020 20:26:15 */
  statesdot[0] = states[1];
  statesdot[1] = controls[0];
  statesdot[2] = states[3];
  statesdot[3] = controls[1];

  /*  Hessian Jacobian for sys_de333256aa3f64854082fd9b6efede0c */
  for (i0 = 0; i0 < 6; i0++) {
    c_tmp_j_input_sys_de333256aa3f6[6 * i0] = j_x[i0];
    c_tmp_j_input_sys_de333256aa3f6[1 + 6 * i0] = j_vX[i0];
    c_tmp_j_input_sys_de333256aa3f6[2 + 6 * i0] = j_y[i0];
    c_tmp_j_input_sys_de333256aa3f6[3 + 6 * i0] = j_vY[i0];
    c_tmp_j_input_sys_de333256aa3f6[4 + 6 * i0] = j_aX[i0];
    c_tmp_j_input_sys_de333256aa3f6[5 + 6 * i0] = j_aY[i0];
  }

  /*  Calculation of Jacobian with respect to function global input for sys_de333256aa3f64854082fd9b6efede0c */
  for (i0 = 0; i0 < 4; i0++) {
    for (i1 = 0; i1 < 6; i1++) {
      j_statedottmp[i0 + (i1 << 2)] = 0.0;
      for (i2 = 0; i2 < 6; i2++) {
        j_statedottmp[i0 + (i1 << 2)] += (double)(b_j_statedottmp[i0 + (i2 << 2)]
          * c_tmp_j_input_sys_de333256aa3f6[i2 + 6 * i1]);
      }
    }
  }

  /*  Combine Variables to statesdot */
  /*  Combine Variables to outputs */
  outputs[0] = states[0];
  outputs[1] = states[1];
  outputs[2] = states[2];
  outputs[3] = states[3];
  for (i0 = 0; i0 < 6; i0++) {
    j_statesdot[i0 << 2] = j_statedottmp[i0 << 2];
    j_statesdot[1 + (i0 << 2)] = j_statedottmp[1 + (i0 << 2)];
    j_statesdot[2 + (i0 << 2)] = j_statedottmp[2 + (i0 << 2)];
    j_statesdot[3 + (i0 << 2)] = j_statedottmp[3 + (i0 << 2)];
    j_xOut[i0] = 0.0;
    j_vxOut[i0] = 0.0;
    j_yOut[i0] = 0.0;
    j_vyOut[i0] = 0.0;
    for (i1 = 0; i1 < 6; i1++) {
      j_xOut[i0] += (double)(b_j_xOut[i1] * c_tmp_j_input_sys_de333256aa3f6[i1 +
        6 * i0]);
      j_vxOut[i0] += (double)(b_j_vxOut[i1] * c_tmp_j_input_sys_de333256aa3f6[i1
        + 6 * i0]);
      j_yOut[i0] += (double)(b_j_yOut[i1] * c_tmp_j_input_sys_de333256aa3f6[i1 +
        6 * i0]);
      j_vyOut[i0] += (double)(b_j_vyOut[i1] * c_tmp_j_input_sys_de333256aa3f6[i1
        + 6 * i0]);
    }

    j_outputs[i0 << 2] = j_xOut[i0];
    j_outputs[1 + (i0 << 2)] = j_vxOut[i0];
    j_outputs[2 + (i0 << 2)] = j_yOut[i0];
    j_outputs[3 + (i0 << 2)] = j_vyOut[i0];
  }
}

void mb_fm_mex_sourceRobot_initialize()
{
}

void mb_fm_mex_sourceRobot_terminate()
{
  /* (no terminate code required) */
}

/* End of code generation (mb_fm_mex_sourceRobot.cpp) */
